#include "headers.h"

MODULE = Arisa::Admin  PACKAGE = Arisa
PROTOTYPES: ENABLE

void
admins()
PREINIT:
	int i;
PPCODE:
	LOCK(global);
	for(i = 0; i < global->no_admins; ++i) {
		chat_t *ac = global->admins[i];
		LOCK(ac);
		if(ac->state != STATE_COMPLETE)
			XPUSHs(sv_2mortal(
				create_ptr_object("Arisa::Admin",ac)));
		UNLOCK(ac);
	}
	UNLOCK(global);
	
#*******************************
MODULE = Arisa::Admin  PACKAGE = Arisa::Admin
#*******************************

SV*
close(ac)
	Arisa::Admin ac
CODE:
	RETVAL = &PL_sv_no;
	if(admin_valid(ac)) {
		if(ac->state != STATE_COMPLETE && ac->state != STATE_DELETED) {
			ac->state = STATE_DELETED;
			RETVAL = &PL_sv_yes;
		}
		UNLOCK(ac);
	}
OUTPUT:
	RETVAL

void
info(ac)
	Arisa::Admin ac
PREINIT:
	HV *hv = NULL;
PPCODE:
	if(admin_valid(ac)) {
		hv = chat_to_hv(ac);
		UNLOCK(ac);
	}
	RET_REF(hv);

SV*
send_msg(ac, message)
	Arisa::Admin ac
	char *message
CODE:
	RETVAL = &PL_sv_no;
	if(admin_valid(ac) && message != NULL) {
		pqueue_push_back(&(ac->msgqueue),xstrdup(message));
		UNLOCK(ac);
		RETVAL = &PL_sv_yes;
	}
OUTPUT:
	RETVAL
